import org.omg.CORBA.*;
import org.omg.CosNaming.*;
import msql.*;
import java.util.*;

/**
 * This type was created in VisualAge.
 */
public class MsqlConnector {

    ORB orb = null;
    Query query = null;

    /**
     * MsqlConnector constructor comment.
     */
    public MsqlConnector(ORB o) {
	super();
      	try {
    	    // create and initialize the ORB
	    orb = o;
	    // get the root naming context
	    org.omg.CORBA.Object objRef = 
		orb.resolve_initial_references("NameService");
	    NamingContext ncRef = NamingContextHelper.narrow(objRef);
	    
	    // resolve the Object Reference in Naming
	    NameComponent nc = new NameComponent("MsqlQuery", "");
	    NameComponent path[] = {nc};
	    query = QueryHelper.narrow(ncRef.resolve(path));
	} catch (Exception e) {
	    System.out.println("ERROR : " + e) ;
	    e.printStackTrace(System.out);
	}
	}
    /**
     * This method was created in VisualAge.
     * @return java.lang.String[]
     * @param s java.lang.String
     */
    public String[] doQuery(String s) {
	String[] ss = null;

	Result rs = null;
	
	try {
	    rs = query.doQuery(s);
	} catch (SqlException e) {
	    ss = new String[1];
	    ss[0] = "Exception: "+e.Message;
	}
	    
	Vector vector = new Vector();

	while (rs.hasMoreRows()) {
	    String[] ss2 = null;
	    try {
	    	ss2 = rs.getNextRow();
    	    } catch (SqlException e) {
		break;
	    }
	    String s2 = "";
	    for (int i = 0; i < ss2.length; i++)
		s2 += ss2[i] + ", ";
	    vector.add(s2);
	}

	ss = new String[vector.size()];
	vector.toArray(ss);
	    
	return ss;
    }
}
