 
import msql.*;
import java.sql.*;
import java.util.*;
import org.omg.CORBA.*;


class QueryServant extends _QueryImplBase {

    ORB orb;
    Connection con;

    QueryServant(ORB o) {
	orb = o;
    }
	
    private void connectToSql() throws Exception {
	String url = "jdbc:msql://localhost:1114/DBTest";
	Properties p = new Properties();
  
	p.put("user", "balazs");
       	Class.forName("com.imaginary.sql.msql.MsqlDriver");
   	con = DriverManager.getConnection(url, "balazs", "");
		System.out.println( " Database Connection Created!" );
		
    }
    public Result doQuery(String query) throws msql.SqlException {
    	ResultServant result = new ResultServant();
	try 
	  {
	    orb.connect(result);
	  
	    debug(query);
	    
	    connectToSql();
	    
	    Statement stmt;
	    ResultSet rs;
	    stmt = con.createStatement();
	    rs = stmt.executeQuery(query);
	    ResultSetMetaData meta = rs.getMetaData();
	    
	    int n = meta.getColumnCount();

	    while( rs.next() ) 
	      {
		String[] row = new String[n];
		for (int i = 0; i < n; i++) {
		  java.lang.Object o = rs.getObject(i+1);
		  row[i] = o.toString();
		}
    	    
	       	result.addRow(row);
		
	      }
	    
	    con.close();
	    
	  } 
	catch (SQLException me)
	  {
	    String[] sa = new String[1];
	    sa[0] = me.getMessage();
	    result.addRow(sa);
	    debug(me.getMessage());
	  
	  } 
	catch (Exception e) 
	  {
	    System.err.println(e);
	  }
       	return result;
       	
    }
	
    void debug(String s)
      {
	System.err.println("QueryServant: "+s);
      }


}


